#include <amxmodx>
#include <amxmisc>
#include <cstrike>
#include <hamsandwich>
#include <nfvault>
#include <regex>
#include <hnsxp_const>
#include <hnsxp_stocks>


#pragma semicolon 1

enum _:Ability
{
	ABIL_name[32],
	Array:ABIL_items,
	Array:ABIL_descs
};

enum _:Item
{
	ITEM_name[32],
	ITEM_save_name[32],
	ITEM_value_type[32],
	ITEM_first_xp,
	ITEM_level_interval,
	ITEM_max_level,
	ITEM_max_value,
	ITEM_player_levels[33]
};

new Array:g_abilities;

new g_authid[33][35];

new g_xp[33];

new g_first_time[33];

new g_menu_ability[33];
new g_menu_item[33];
new g_menu_player[33];

new cvar_message_prefix;
new cvar_xp_entry;
new cvar_xp_suicide;
new cvar_xp_kill;
new cvar_xp_headshot;
new cvar_xp_grenade;
new cvar_xp_survive;
new cvar_xp_win;
new cvar_sell_percent;

new g_vault_file[128];

new g_fwd_update_user_level;
new g_fwd_return;

new Regex:g_SteamID_pattern;
new g_regex_return;

new g_first_client;
new g_max_clients;

new g_msgid_SayText;

public plugin_init()
{
	register_plugin("HideNSeek XP Mod", HNSXP_VERSION, "Exolent");
	register_cvar("hnsxp_author", "Exolent", FCVAR_SPONLY);
	register_cvar("hnsxp_version", HNSXP_VERSION, FCVAR_SPONLY);
	
	register_clcmd("say /xp", "CmdMainMenu");
	register_clcmd("say /exp", "CmdMainMenu");
	
	register_concmd("hnsxp_give_xp", "CmdGiveXP", ADMIN_RCON, "<nick, #userid, authid> <xp>");
	register_concmd("hnsxp_remove_xp", "CmdRemoveXP", ADMIN_RCON, "<nick, #userid, authid> <xp>");
	
	register_event("DeathMsg", "EventDeathMsg", "a");
	register_logevent("EventRoundEnd", 2, "1=Round_End");
	
	RegisterHam(Ham_Spawn, "player", "FwdPlayerSpawn", 1);
	
	cvar_message_prefix = register_cvar("hnsxp_message_prefix", "[HNS XP]");
	cvar_xp_entry = register_cvar("hnsxp_xp_entry", "100");
	cvar_xp_suicide = register_cvar("hnsxp_xp_suicide", "5");
	cvar_xp_kill = register_cvar("hnsxp_xp_kill", "4");
	cvar_xp_headshot = register_cvar("hnsxp_xp_headshot", "3");
	cvar_xp_grenade = register_cvar("hnsxp_xp_grenade", "6");
	cvar_xp_survive = register_cvar("hnsxp_xp_survive", "2");
	cvar_xp_win = register_cvar("hnsxp_xp_win", "3");
	cvar_sell_percent = register_cvar("hnsxp_sell_percent", "80");
	
	g_abilities = ArrayCreate(Ability);
	
	nfv_file("hns_xp", g_vault_file, 127);
	
	g_fwd_update_user_level = CreateMultiForward("hnsxp_update_user_level", ET_IGNORE, FP_CELL, FP_CELL, FP_CELL, FP_CELL);
	
	new err[2];
	g_SteamID_pattern = regex_compile("^^STEAM_0:(0|1):\d+$", g_regex_return, err, sizeof(err) - 1);
	
	g_first_client = 1;
	g_max_clients = get_maxplayers();
	
	g_msgid_SayText = get_user_msgid("SayText");
}

public plugin_end()
{
	new ability_total = ArraySize(g_abilities);
	new ability_data[Ability];
	
	for( new i = 0; i < ability_total; i++ )
	{
		ArrayGetArray(g_abilities, i, ability_data);
		
		ArrayDestroy(ability_data[ABIL_items]);
		ArrayDestroy(ability_data[ABIL_descs]);
	}
	
	ArrayDestroy(g_abilities);
}

public plugin_natives()
{
	register_library("hns_xp");
	
	register_native("hnsxp_register_ability", "_register_ability");
	register_native("hnsxp_register_item", "_register_item");
	register_native("hnsxp_describe_ability", "_describe_ability");
	
	register_native("hnsxp_get_user_xp", "_get_user_xp");
	register_native("hnsxp_set_user_xp", "_set_user_xp");
	register_native("hnsxp_get_authid_xp", "_get_authid_xp");
	register_native("hnsxp_set_authid_xp", "_set_authid_xp");
	
	register_native("hnsxp_print", "_print");
}

public _register_ability(plugin, params)
{
	new ability_data[Ability];
	get_string(1, ability_data[ABIL_name], sizeof(ability_data[ABIL_name]) - 1);
	ability_data[ABIL_items] = _:ArrayCreate(Item);
	ability_data[ABIL_descs] = _:ArrayCreate(256);
	
	new total = ArraySize(g_abilities);
	
	ArrayPushArray(g_abilities, ability_data);
	
	return total;
}

public _register_item(plugin, params)
{
	new ability = get_param(1);
	new ability_data[Ability];
	ArrayGetArray(g_abilities, ability, ability_data);
	
	new item_data[Item];
	get_string(2, item_data[ITEM_name], sizeof(item_data[ITEM_name]) - 1);
	get_string(3, item_data[ITEM_save_name], sizeof(item_data[ITEM_save_name]) - 1);
	get_string(4, item_data[ITEM_value_type], sizeof(item_data[ITEM_value_type]) - 1);
	item_data[ITEM_first_xp] = get_param(5);
	item_data[ITEM_level_interval] = get_param(6);
	item_data[ITEM_max_level] = get_param(7);
	item_data[ITEM_max_value] = get_param(8);
	
	new total = ArraySize(ability_data[ABIL_items]);
	
	ArrayPushArray(ability_data[ABIL_items], item_data);
	
	return total;
}

public _describe_ability(plugin, params)
{
	new ability = get_param(1);
	new description[256];
	get_string(2, description, sizeof(description) - 1);
	
	new ability_data[Ability];
	ArrayGetArray(g_abilities, ability, ability_data);
	
	ArrayPushString(ability_data[ABIL_descs], description);
	
	return 1;
}

public _get_user_xp(plugin, params)
{
	return g_xp[get_param(1)];
}

public _set_user_xp(plugin, params)
{
	new client = get_param(1);
	if( IsUserAuthorized(client) )
	{
		g_xp[client] = max(0, get_param(2));
		nfv_set_num(g_vault_file, g_authid[client], "xp", g_xp[client]);
	}
	return g_xp[client];
}

public _get_authid_xp(plugin, params)
{
	new authid[35];
	get_string(1, authid, sizeof(authid) - 1);
	
	return IsValidAuthid(authid) ? nfv_get_num(g_vault_file, authid, "xp") : 0;
}

public _set_authid_xp(plugin, params)
{
	new authid[35];
	get_string(1, authid, sizeof(authid) - 1);
	
	if( !IsValidAuthid(authid) )
	{
		return 0;
	}
	
	new xp = max(0, get_param(2));
	nfv_set_num(g_vault_file, authid, "xp", xp);
	
	return xp;
}

public _print(plugin, params)
{
	new client = get_param(1);
	
	new message[192];
	vdformat(message, sizeof(message) - 1, 2, 3);
	
	Print(client, "%s", message);
	
	return 1;
}

public client_authorized(client)
{
	if( !is_user_bot(client) && !is_user_hltv(client) )
	{
		/* is this still called in LAN, non-steam, etc? */
		get_user_authid(client, g_authid[client], sizeof(g_authid[]) - 1);
		
		if( !IsValidAuthid(g_authid[client]) )
		{
			g_authid[client][0] = 0;
		}
		else
		{
			Load(client);
		}
	}
}

public client_disconnect(client)
{
	g_xp[client] = 0;
	g_authid[client][0] = 0;
	g_first_time[client] = 0;
	
	new ability_total = ArraySize(g_abilities);
	
	new ability_data[Ability], item_total, item_data[Item];
	for( new i = 0, j; i < ability_total; i++ )
	{
		ArrayGetArray(g_abilities, i, ability_data);
		
		item_total = ArraySize(ability_data[ABIL_items]);
		
		for( j = 0; j < item_total; j++ )
		{
			ArrayGetArray(ability_data[ABIL_items], j, item_data);
			
			item_data[ITEM_player_levels][client] = 0;
			
			ArraySetArray(ability_data[ABIL_items], j, item_data);
			
			ExecuteForward(g_fwd_update_user_level, g_fwd_return, i, j, client, 0);
		}
	}
	
	for( new i = 1; i <= g_max_clients; i++ )
	{
		if( g_menu_player[i] == client )
		{
			g_menu_player[i] = 0;
		}
	}
}

public CmdMainMenu(client)
{
	ShowMainMenu(client);
}

public CmdGiveXP(client, level, cid)
{
	if( !cmd_access(client, level, cid, 3) ) return PLUGIN_HANDLED;
	
	static arg[35];
	read_argv(1, arg, sizeof(arg) - 1);
	
	new target = cmd_target(client, arg, CMDTARGET_OBEY_IMMUNITY|CMDTARGET_NO_BOTS|CMDTARGET_ALLOW_SELF);
	if( !target ) return PLUGIN_HANDLED;
	
	if( !IsUserAuthorized(target) )
	{
		console_print(client, "Target has not authorized with the server.");
		return PLUGIN_HANDLED;
	}
	
	read_argv(2, arg, sizeof(arg) - 1);
	new xp = str_to_num(arg);
	
	if( xp <= 0 )
	{
		console_print(client, "XP must be a value greater than 0!");
		if( xp < 0 )
		{
			console_print(client, "Use hnsxp_remove_xp instead.");
		}
		return PLUGIN_HANDLED;
	}
	
	g_xp[target] += xp;
	
	nfv_set_num(g_vault_file, g_authid[target], "xp", g_xp[target]);
	
	static name[2][32];
	get_user_name(client, name[0], sizeof(name[]) - 1);
	get_user_name(target, name[1], sizeof(name[]) - 1);
	
	Print(0, "^3 %s^1 gave^3 %i XP^1 to^3 %s", name[0], xp, name[1]);
	
	static steamid[2][35];
	get_user_authid(client, steamid[0], sizeof(steamid[]) - 1);
	get_user_authid(target, steamid[1], sizeof(steamid[]) - 1);
	
	log_amx("%s (%s) gave %i XP to %s (%s)", name[0], steamid[0], xp, name[1], steamid[1]);
	
	return PLUGIN_HANDLED;
}

public CmdRemoveXP(client, level, cid)
{
	if( !cmd_access(client, level, cid, 3) ) return PLUGIN_HANDLED;
	
	static arg[35];
	read_argv(1, arg, sizeof(arg) - 1);
	
	new target = cmd_target(client, arg, CMDTARGET_OBEY_IMMUNITY|CMDTARGET_NO_BOTS|CMDTARGET_ALLOW_SELF);
	if( !target ) return PLUGIN_HANDLED;
	
	if( !IsUserAuthorized(target) )
	{
		console_print(client, "Target has not authorized with the server.");
		return PLUGIN_HANDLED;
	}
	
	read_argv(2, arg, sizeof(arg) - 1);
	new xp = str_to_num(arg);
	
	if( xp <= 0 )
	{
		console_print(client, "XP must be a value greater than 0!");
		if( xp < 0 )
		{
			console_print(client, "Use hnsxp_give_xp instead.");
		}
		return PLUGIN_HANDLED;
	}
	
	if( g_xp[target] < xp )
	{
		xp = g_xp[target];
	}
	
	g_xp[target] -= xp;
	
	nfv_set_num(g_vault_file, g_authid[target], "xp", g_xp[target]);
	
	static name[2][32];
	get_user_name(client, name[0], sizeof(name[]) - 1);
	get_user_name(target, name[1], sizeof(name[]) - 1);
	
	Print(0, "^3 %s^1 removed^3 %i XP^1 from^3 %s", name[0], xp, name[1]);
	
	static steamid[2][35];
	get_user_authid(client, steamid[0], sizeof(steamid[]) - 1);
	get_user_authid(target, steamid[1], sizeof(steamid[]) - 1);
	
	log_amx("%s (%s) removed %i XP from %s (%s)", name[0], steamid[0], xp, name[1], steamid[1]);
	
	return PLUGIN_HANDLED;
}

public EventDeathMsg()
{
	new killer = read_data(1);
	new victim = read_data(2);
	
	if( (g_first_client <= killer <= g_max_clients) && victim != killer )
	{
		if( IsUserAuthorized(killer) )
		{
			static extra[64];
			extra[0] = 0;
			
			// regular kill
			new xp = get_pcvar_num(cvar_xp_kill);
			
			if( read_data(3) )
			{
				new headshot = get_pcvar_num(cvar_xp_headshot);
				if( headshot )
				{
					// headshot kill
					xp += headshot;
					
					copy(extra, sizeof(extra) - 1, " with a^3 headshot^1");
				}
			}
			else
			{
				new grenade = get_pcvar_num(cvar_xp_grenade);
				if( grenade )
				{
					static weapon[20];
					read_data(4, weapon, sizeof(weapon) - 1);
					
					if( contain(weapon, "grenade") >= 0 )
					{
						// grenade kill (or frostgrenade)
						xp += grenade;
						
						copy(extra, sizeof(extra) - 1, " with a^3 grenade^1");
					}
				}
			}
			
			if( xp )
			{
				if( g_xp[killer] < (xp * -1) )
				{
					// xp is negative
					// make sure killer's xp doesn't go below 0
					xp = g_xp[killer] * -1;
				}
				
				if( xp )
				{
					if( cs_get_user_team(killer) == cs_get_user_team(victim) )
					{
						xp *= -1;
					}
					
					g_xp[killer] += xp;
					
					static name[32];
					get_user_name(victim, name, sizeof(name) - 1);
					
					Print(killer, "^1 You %s^3 %i XP^1 for killing^3 %s^1%s!", xp > 0 ? "gained" : "lost", xp, name, extra);
					
					nfv_set_num(g_vault_file, g_authid[killer], "xp", g_xp[killer]);
				}
			}
		}
	}
	else if( IsUserAuthorized(victim) )
	{
		// victim died of map causes or killed self
		new xp = get_pcvar_num(cvar_xp_suicide);
		if( xp )
		{
			if( g_xp[victim] < xp )
			{
				xp = g_xp[victim];
			}
			
			if( xp )
			{
				g_xp[victim] -= xp;
				
				Print(victim, "^1 You %s^3 %i XP^1 for suiciding!", xp < 0 ? "gained" : "lost", xp);
				
				nfv_set_num(g_vault_file, g_authid[victim], "xp", g_xp[victim]);
			}
		}
	}
}

public EventRoundEnd()
{
	new hider, seeker, hider_alive;
	
	for( new i = g_first_client; i <= g_max_clients; i++ )
	{
		if( is_user_connected(i) )
		{
			switch( cs_get_user_team(i) )
			{
				case CS_TEAM_CT:
				{
					if( !seeker )
					{
						seeker = i;
					}
				}
				case CS_TEAM_T:
				{
					if( !hider )
					{
						hider = i;
						
						if( !hider_alive && is_user_alive(i) )
						{
							hider_alive = i;
						}
					}
				}
			}
			
			if( seeker && hider && hider_alive )
			{
				break;
			}
		}
	}
	
	if( !hider || !seeker )
	{
		return;
	}
	
	new CsTeams:winner = CS_TEAM_CT;
	
	new bool:update[33];
	
	if( hider_alive )
	{
		winner = CS_TEAM_T;
		
		new survive = get_pcvar_num(cvar_xp_survive);
		if( survive )
		{
			new xp;
			for( new client = g_first_client; client <= g_max_clients; client++ )
			{
				if( IsUserAuthorized(client) && is_user_alive(client) && cs_get_user_team(client) == CS_TEAM_T )
				{
					xp = survive;
					if( g_xp[client] < (survive * -1) )
					{
						xp = g_xp[client] * -1;
					}
					
					if( xp )
					{
						g_xp[client] += xp;
						update[client] = true;
						
						Print(client, "^1 You %s^3 %i XP^1 for surviving!", xp > 0 ? "gained" : "lost", xp);
					}
				}
			}
		}
	}
	
	new win = get_pcvar_num(cvar_xp_win);
	if( win )
	{
		new xp;
		for( new client = g_first_client; client <= g_max_clients; client++ )
		{
			if( IsUserAuthorized(client) && is_user_alive(client) && cs_get_user_team(client) == winner )
			{
				xp = win;
				if( g_xp[client] < (win * -1) )
				{
					xp = g_xp[client] * -1;
				}
				
				if( xp )
				{
					g_xp[client] += xp;
					update[client] = true;
					
					Print(client, "^1 You %s^3 %i XP^1 for winning the round!", xp > 0 ? "gained" : "lost", xp);
				}
			}
		}
	}
	
	for( new client = g_first_client; client <= g_max_clients; client++ )
	{
		if( update[client] )
		{
			nfv_set_num(g_vault_file, g_authid[client], "xp", g_xp[client]);
		}
	}
}

public FwdPlayerSpawn(client)
{
	if( is_user_alive(client) )
	{
		if( g_first_time[client] )
		{
			Print(client, "^1 It is your first time playing this^3 HideNSeek XP mod^1, so you are rewarded with^3 %i XP^1!", get_pcvar_num(cvar_xp_entry));
			Print(client, "^1 You earn XP based upon your gameplay, and you can buy more levels in the menu.");
			Print(client, "^1 Type^3 /xp^1 to view what you can get!");
			
			g_first_time[client] = 0;
		}
	}
}

ShowMainMenu(client)
{
	static title[512], len;
	len = copy(title, sizeof(title) - 1, "[HNS XP by Exolent]");
	
	if( IsUserAuthorized(client) )
	{
		len += formatex(title[len], sizeof(title) - len - 1, "^nYour XP: \w%i", g_xp[client]);
	}
	
	len += copy(title[len], sizeof(title) - len - 1, "^n^n\yMain Menu");
	
	new menu = menu_create(title, "MenuMain");
	
	menu_additem(menu, "\yHelp", "1");
	menu_additem(menu, "Abilities", "2");
	menu_additem(menu, "Player Info", "3");
	menu_additem(menu, "\rReset All", "4");
	
	menu_display(client, menu);
}

public MenuMain(client, menu, item)
{
	if( item == MENU_EXIT )
	{
		menu_destroy(menu);
		return;
	}
	
	static _access, info[4], callback;
	menu_item_getinfo(menu, item, _access, info, sizeof(info) - 1, _, _, callback);
	menu_destroy(menu);
	
	switch( info[0] )
	{
		case '1':
		{
			static motd[2500];
			new len = formatex(motd, sizeof(motd) - 1,	"<html>");
			len += format(motd[len], sizeof(motd) - len - 1,	"<body style=^"background-color:#030303; color:#FF8F00^">");
			len += format(motd[len], sizeof(motd) - len - 1,	"<p align=^"center^">");
			len += format(motd[len], sizeof(motd) - len - 1,	"HideNSeek XP Mod is an experienced based addon for HideNSeek.<br>");
			len += format(motd[len], sizeof(motd) - len - 1,	"Players earn experience points by how well they play the game.<br>");
			len += format(motd[len], sizeof(motd) - len - 1,	"<br>");
			len += format(motd[len], sizeof(motd) - len - 1,	"<table border=0 cellspacing=0 cellpadding=3>");
			len += format(motd[len], sizeof(motd) - len - 1,	"<tr><th style=^"text-align: left;^">Action</th><th style=^"text-align: left;^">XP</th></tr>");
			len += format(motd[len], sizeof(motd) - len - 1,	"<tr><td>Kill</td><td>+%i</td></tr>", get_pcvar_num(cvar_xp_kill));
			len += format(motd[len], sizeof(motd) - len - 1,	"<tr><td>Grenade</td><td>+%i</td></tr>", get_pcvar_num(cvar_xp_grenade));
			len += format(motd[len], sizeof(motd) - len - 1,	"<tr><td>Headshot</td><td>+%i</td></tr>", get_pcvar_num(cvar_xp_headshot));
			len += format(motd[len], sizeof(motd) - len - 1,	"<tr><td>Suicide</td><td>-%i</td></tr>", get_pcvar_num(cvar_xp_suicide));
			len += format(motd[len], sizeof(motd) - len - 1,	"<tr><td>Survive as a T</td><td>+%i</td></tr>", get_pcvar_num(cvar_xp_survive));
			len += format(motd[len], sizeof(motd) - len - 1,	"<tr><td>Win Round</td><td>+%i</td></tr>", get_pcvar_num(cvar_xp_win));
			len += format(motd[len], sizeof(motd) - len - 1,	"</table>");
			len += format(motd[len], sizeof(motd) - len - 1,	"With these XP points, you can buy ability items.<br>");
			len += format(motd[len], sizeof(motd) - len - 1,	"For a list of these items, type /xp again and view the other menus inside.");
			len += format(motd[len], sizeof(motd) - len - 1,	"</p>");
			len += format(motd[len], sizeof(motd) - len - 1,	"</body>");
			len += format(motd[len], sizeof(motd) - len - 1,	"</html>");
			
			show_motd(client, motd, "HideNSeek XP Mod Info");
			
			ShowMainMenu(client);
		}
		case '2':
		{
			if( IsUserAuthorized(client) )
			{
				ShowAbilityMenu(client);
			}
			else
			{
				Print(client, "^1 You must authorize your SteamID with the server before accessing these menus!" );
			}
		}
		case '3':
		{
			if( IsUserAuthorized(client) )
			{
				ShowPlayerMenu(client);
			}
			else
			{
				Print(client, "^1 You must authorize your SteamID with the server before accessing these menus!" );
			}
		}
		case '4':
		{
			if( IsUserAuthorized(client) )
			{
				ShowResetMenu(client);
			}
			else
			{
				Print(client, "^1 You must authorize your SteamID with the server before accessing these menus!" );
			}
		}
	}
}

ShowAbilityMenu(client, page=0)
{
	static title[512];
	formatex(title, sizeof(title) - 1, "[HNS XP by Exolent]^nYour XP: \w%i^n^n\yAbility Menu", g_xp[client]);
	new menu = menu_create(title, "MenuAbility");
	
	new ability_total = ArraySize(g_abilities);
	new ability_data[Ability], num[3];
	for( new i = 0; i < ability_total; i++ )
	{
		ArrayGetArray(g_abilities, i, ability_data);
		
		num_to_str(i, num, sizeof(num) - 1);
		
		menu_additem(menu, ability_data[ABIL_name], num);
	}
	
	menu_setprop(menu, MPROP_EXITNAME, "Main Menu");
	
	menu_display(client, menu, page);
}

public MenuAbility(client, menu, item)
{
	if( item == MENU_EXIT )
	{
		menu_destroy(menu);
		ShowMainMenu(client);
		return;
	}
	
	static _access, info[4], callback;
	menu_item_getinfo(menu, item, _access, info, sizeof(info) - 1, _, _, callback);
	menu_destroy(menu);
	
	g_menu_ability[client] = str_to_num(info);
	
	ShowItemMenu(client);
}

ShowItemMenu(client, page=0)
{
	new ability_data[Ability];
	ArrayGetArray(g_abilities, g_menu_ability[client], ability_data);
	
	static title[512];
	formatex(title, sizeof(title) - 1, "[HNS XP by Exolent]^nYour XP: \w%i^n^n\y%s Menu", g_xp[client], ability_data[ABIL_name]);
	new menu = menu_create(title, "MenuItem");
	
	menu_additem(menu, "\yHelp", "*");
	
	new item_total = ArraySize(ability_data[ABIL_items]);
	new item_data[Item], num[3], item[64];
	for( new i = 0; i < item_total; i++ )
	{
		ArrayGetArray(ability_data[ABIL_items], i, item_data);
		
		num_to_str(i, num, sizeof(num) - 1);
		
		if( item_data[ITEM_player_levels][client] < item_data[ITEM_max_level] )
		{
			menu_additem(menu, item_data[ITEM_name], num);
		}
		else
		{
			formatex(item, sizeof(item) - 1, "%s \r[\yMaxed Out!\r]", item_data[ITEM_name]);
			menu_additem(menu, item, num);
		}
	}
	
	formatex(item, sizeof(item) - 1, "%s Menu", ability_data[ABIL_name]);
	menu_setprop(menu, MPROP_EXITNAME, item);
	
	menu_display(client, menu, page);
}

public MenuItem(client, menu, item)
{
	if( item == MENU_EXIT )
	{
		menu_destroy(menu);
		ShowAbilityMenu(client, (g_menu_ability[client] / 7));
		return;
	}
	
	static _access, info[4], callback;
	menu_item_getinfo(menu, item, _access, info, sizeof(info) - 1, _, _, callback);
	menu_destroy(menu);
	
	if( info[0] == '*' )
	{
		new ability_data[Ability];
		ArrayGetArray(g_abilities, g_menu_ability[client], ability_data);
		
		new description[256];
		new descs_total = ArraySize(ability_data[ABIL_descs]);
		
		new item_data[Item];
		new item_total = ArraySize(ability_data[ABIL_items]);
		
		static motd[2500];
		new len = formatex(motd, sizeof(motd) - 1,		"<html><body style=^"background-color:#030303; color:#FF8F00^">");
		len += formatex(motd[len], sizeof(motd) - len - 1,	"<p align=^"center^">");
		for( new i = 0; i < descs_total; i++ )
		{
			ArrayGetString(ability_data[ABIL_descs], i, description, sizeof(description) - 1);
			len += formatex(motd[len], sizeof(motd) - len - 1, "%s<br>", description);
		}
		len += formatex(motd[len], sizeof(motd) - len - 1,	"<br>");
		len += formatex(motd[len], sizeof(motd) - len - 1,	"<table align=^"center^">");
		len += formatex(motd[len], sizeof(motd) - len - 1,	"<tr>");
		len += formatex(motd[len], sizeof(motd) - len - 1,	"<th></th>");
		for( new i = 0; i < item_total; i++ )
		{
			ArrayGetArray(ability_data[ABIL_items], i, item_data);
			
			len += formatex(motd[len], sizeof(motd) - len - 1,	"<th>%s</th>", item_data[ITEM_name]);
		}
		len += formatex(motd[len], sizeof(motd) - len - 1,	"</tr>");
		len += formatex(motd[len], sizeof(motd) - len - 1,	"<tr>");
		len += formatex(motd[len], sizeof(motd) - len - 1,	"<th>Value Intervals</th>");
		for( new i = 0; i < item_total; i++ )
		{
			ArrayGetArray(ability_data[ABIL_items], i, item_data);
			
			len += formatex(motd[len], sizeof(motd) - len - 1,	"<td>%i%s</td>", (item_data[ITEM_max_value] / item_data[ITEM_max_level]), item_data[ITEM_value_type]);
		}
		len += formatex(motd[len], sizeof(motd) - len - 1,	"</tr>");
		len += formatex(motd[len], sizeof(motd) - len - 1,	"<tr>");
		len += formatex(motd[len], sizeof(motd) - len - 1,	"<th>Max Level</th>");
		for( new i = 0; i < item_total; i++ )
		{
			ArrayGetArray(ability_data[ABIL_items], i, item_data);
			
			len += formatex(motd[len], sizeof(motd) - len - 1,	"<td>%i</td>", item_data[ITEM_max_level]);
		}
		len += formatex(motd[len], sizeof(motd) - len - 1,	"</tr>");
		len += formatex(motd[len], sizeof(motd) - len - 1,	"<tr>");
		len += formatex(motd[len], sizeof(motd) - len - 1,	"<th>Max Value</th>");
		for( new i = 0; i < item_total; i++ )
		{
			ArrayGetArray(ability_data[ABIL_items], i, item_data);
			
			len += formatex(motd[len], sizeof(motd) - len - 1,	"<td>%i%s</td>", item_data[ITEM_max_value], item_data[ITEM_value_type]);
		}
		len += formatex(motd[len], sizeof(motd) - len - 1,	"</tr>");
		len += formatex(motd[len], sizeof(motd) - len - 1,	"<tr>");
		len += formatex(motd[len], sizeof(motd) - len - 1,	"<th style=^"vertical-align: top;^">XP Intervals</th>");
		for( new i = 0, j; i < item_total; i++ )
		{
			ArrayGetArray(ability_data[ABIL_items], i, item_data);
			
			len += formatex(motd[len], sizeof(motd) - len - 1,	"<td style=^"vertical-align: top;^">");
			for( j = 1; j <= item_data[ITEM_max_level]; j++ )
			{
				len += formatex(motd[len], sizeof(motd) - len - 1, 	"%s%i", j == 1 ? "" : "<br>", hnsxp_calculate_xp(item_data[ITEM_first_xp], item_data[ITEM_level_interval], j));
			}
			len += formatex(motd[len], sizeof(motd) - len - 1,	"</td>");
		}
		len += formatex(motd[len], sizeof(motd) - len - 1,	"</tr>");
		len += formatex(motd[len], sizeof(motd) - len - 1,	"</table>");
		len += formatex(motd[len], sizeof(motd) - len - 1,	"</p>");
		len += formatex(motd[len], sizeof(motd) - len - 1,	"</body></html>");
		
		formatex(description, sizeof(description) - 1, "HNS XP Mod %s Info", ability_data[ABIL_name]);
		show_motd(client, motd, description);
		
		ShowItemMenu(client);
	}
	else
	{
		g_menu_item[client] = str_to_num(info);
		
		ShowItemOptionsMenu(client);
	}
}

ShowItemOptionsMenu(client)
{
	new ability_data[Ability];
	ArrayGetArray(g_abilities, g_menu_ability[client], ability_data);
	
	new item_data[Item];
	ArrayGetArray(ability_data[ABIL_items], g_menu_item[client], item_data);
	
	static title[512];
	formatex(title, sizeof(title) - 1, "[HNS XP by Exolent]^nYour XP: \w%i^n^n\y%s Menu^n%s Options", g_xp[client], ability_data[ABIL_name], item_data[ITEM_name]);
	new menu = menu_create(title, "MenuItemOptions");
	
	static item[128];
	new level = item_data[ITEM_player_levels][client];
	new first_xp = item_data[ITEM_first_xp];
	new interval = item_data[ITEM_level_interval];
	
	if( level < item_data[ITEM_max_level] )
	{
		new xp = hnsxp_calculate_xp(first_xp, interval, (level + 1));
		
		new value = hnsxp_calculate_value((level + 1), item_data[ITEM_max_level], item_data[ITEM_max_value]);
		
		formatex(item, sizeof(item) - 1, "%s: \yBuy Level %i (%i%s) \r[\w%i XP\r]", item_data[ITEM_name], (level + 1), value, item_data[ITEM_value_type], xp);
		menu_additem(menu, item, "1");
	}
	
	if( level > 0 )
	{
		new xp = hnsxp_calculate_xp(first_xp, interval, level) * get_pcvar_num(cvar_sell_percent) / 100;
		
		new value = hnsxp_calculate_value(level, item_data[ITEM_max_level], item_data[ITEM_max_value]);
		
		formatex(item, sizeof(item) - 1, "%s: \ySell Level %i (%i%s) \r[\w%i XP\r]", item_data[ITEM_name], level, value, item_data[ITEM_value_type], xp);
		menu_additem(menu, item, "2");
	}
	
	formatex(item, sizeof(item) - 1, "%s Menu", item_data[ITEM_name]);
	menu_setprop(menu, MPROP_EXITNAME, item);
	
	menu_display(client, menu);
}

public MenuItemOptions(client, menu, item)
{
	if( item == MENU_EXIT )
	{
		menu_destroy(menu);
		ShowItemMenu(client, (g_menu_item[client] / 7));
		return;
	}
	
	static _access, info[4], callback;
	menu_item_getinfo(menu, item, _access, info, sizeof(info) - 1, _, _, callback);
	menu_destroy(menu);
	
	new ability_data[Ability];
	ArrayGetArray(g_abilities, g_menu_ability[client], ability_data);
	
	new item_data[Item];
	ArrayGetArray(ability_data[ABIL_items], g_menu_item[client], item_data);
	
	new level = item_data[ITEM_player_levels][client];
	new first_xp = item_data[ITEM_first_xp];
	new interval = item_data[ITEM_level_interval];
	
	switch( info[0] )
	{
		case '1':
		{
			new xp = hnsxp_calculate_xp(first_xp, interval, (level + 1));
			if( g_xp[client] < xp )
			{
				Print(client, "^1 You need^3 %i more XP^1 to buy this level!", (xp - g_xp[client]));
			}
			else
			{
				new value = hnsxp_calculate_value((level + 1), item_data[ITEM_max_level], item_data[ITEM_max_value]);
				
				Print(client, "^1 You bought^3 %s Level %i^1 (%i%s) for^3 %i XP^1!", item_data[ITEM_name], (level + 1), value, item_data[ITEM_value_type], xp);
				
				g_xp[client] -= xp;
				
				level = ++item_data[ITEM_player_levels][client];
				
				ArraySetArray(ability_data[ABIL_items], g_menu_item[client], item_data);
				
				if( IsUserAuthorized(client) )
				{
					nfv_set_num(g_vault_file, g_authid[client], "xp", g_xp[client]);
					nfv_set_num(g_vault_file, g_authid[client], item_data[ITEM_save_name], level);
				}
				
				ExecuteForward(g_fwd_update_user_level, g_fwd_return, g_menu_ability[client], g_menu_item[client], client, level);
			}
		}
		case '2':
		{
			new xp = hnsxp_calculate_xp(first_xp, interval, level) * get_pcvar_num(cvar_sell_percent) / 100;
			
			if( g_xp[client] < xp )
			{
				Print(client, "^1 You need^3 %i more XP^1 to sell this level!", (xp - g_xp[client]));
			}
			else
			{
				new value = hnsxp_calculate_value(level, item_data[ITEM_max_level], item_data[ITEM_max_value]);
				
				Print(client, "^1 You sold^3 %s Level %i^1 (%i%s) for^3 %i XP^1!", item_data[ITEM_name], level, value, item_data[ITEM_value_type], xp);
				
				g_xp[client] += xp;
				
				level = --item_data[ITEM_player_levels][client];
				
				ArraySetArray(ability_data[ABIL_items], g_menu_item[client], item_data);
				
				if( IsUserAuthorized(client) )
				{
					nfv_set_num(g_vault_file, g_authid[client], "xp", g_xp[client]);
					nfv_set_num(g_vault_file, g_authid[client], item_data[ITEM_save_name], level);
				}
				
				ExecuteForward(g_fwd_update_user_level, g_fwd_return, g_menu_ability[client], g_menu_item[client], client, level);
			}
		}
	}
	
	ShowItemOptionsMenu(client);
}

ShowPlayerMenu(client)
{
	static title[512];
	formatex(title, sizeof(title) - 1, "[HNS XP by Exolent]^nYour XP: \w%i^n^n\yPlayer Info Menu", g_xp[client]);
	
	new menu = menu_create(title, "MenuPlayer");
	
	new name[32], authid[35];
	for( new i = 1; i <= g_max_clients; i++ )
	{
		if( !is_user_connected(i) ) continue;
		
		get_user_name(i, name, sizeof(name) - 1);
		get_user_authid(i, authid, sizeof(authid) - 1);
		
		menu_additem(menu, name, authid);
	}
	
	menu_setprop(menu, MPROP_EXITNAME, "Main Menu");
	
	menu_display(client, menu);
}

public MenuPlayer(client, menu, item)
{
	if( item == MENU_EXIT )
	{
		menu_destroy(menu);
		ShowMainMenu(client);
		return;
	}
	
	static _access, authid[35], callback;
	menu_item_getinfo(menu, item, _access, authid, sizeof(authid) - 1, _, _, callback);
	menu_destroy(menu);
	
	new player = find_player("c", authid);
	if( !is_user_connected(player) )
	{
		ShowPlayerMenu(client);
		return;
	}
	
	g_menu_player[client] = player;
	
	ShowPlayerOptionsMenu(client);
}

ShowPlayerOptionsMenu(client)
{
	static name[32];
	get_user_name(g_menu_player[client], name, sizeof(name) - 1);
	
	static title[512];
	formatex(title, sizeof(title) - 1, "[HNS XP by Exolent]^nYour XP: \w%i^n^n\yPlayer Info Menu^n%s^nPlayer XP: \w%i", g_xp[client], name, g_xp[g_menu_player[client]]);
	new menu = menu_create(title, "MenuPlayerOptions");
	
	new ability_total = ArraySize(g_abilities);
	new ability_data[Ability], num[3];
	for( new i = 0; i < ability_total; i++ )
	{
		ArrayGetArray(g_abilities, i, ability_data);
		num_to_str(i, num, sizeof(num) - 1);
		
		menu_additem(menu, ability_data[ABIL_name], num);
	}
	
	menu_setprop(menu, MPROP_EXITNAME, "Player Menu");
	
	menu_display(client, menu);
}

public MenuPlayerOptions(client, menu, item)
{
	if( item == MENU_EXIT )
	{
		menu_destroy(menu);
		ShowMainMenu(client);
		return;
	}
	
	static _access, info[3], callback;
	menu_item_getinfo(menu, item, _access, info, sizeof(info) - 1, _, _, callback);
	menu_destroy(menu);
	
	new player = g_menu_player[client];
	if( !is_user_connected(player) )
	{
		ShowPlayerMenu(client);
		return;
	}
	
	new name[32];
	get_user_name(player, name, sizeof(name) - 1);
	
	static motd[2500];
	new len = copy(motd, sizeof(motd) - 1, 			"<html><body style=^"background-color:#030303; color:#FF8F00^">");
	len += formatex(motd[len], sizeof(motd) - len - 1,	"<p align=^"center^">");
	len += formatex(motd[len], sizeof(motd) - len - 1,	"<b><font size=^"4^">Name:</font></b> %s<br>", name);
	len += formatex(motd[len], sizeof(motd) - len - 1, 	"<b><font size=^"4^">XP:</font></b> %i<br>", g_xp[player]);
	len += formatex(motd[len], sizeof(motd) - len - 1,	"</p>");
	len += formatex(motd[len], sizeof(motd) - len - 1,	"<table align=^"center^" border=0 cellspacing=0 cellpadding=0><tr><td>");
	
	new ability = str_to_num(info);
	new ability_data[Ability];
	ArrayGetArray(g_abilities, ability, ability_data);
	
	len += formatex(motd[len], sizeof(motd) - len - 1,	"<b><font size=^"4^">%s Levels:</font></b>", ability_data[ABIL_name]);
	
	new item_total = ArraySize(ability_data[ABIL_items]);
	new item_data[Item], level;
	for( new i = 0; i < item_total; i++ )
	{
		ArrayGetArray(ability_data[ABIL_items], i, item_data);
		
		level = item_data[ITEM_player_levels][client];
		
		len += formatex(motd[len], sizeof(motd) - len - 1, "<br><b>%s:</b> %i/%i (%i/%i%s)",\
			item_data[ITEM_name],\
			level,\
			item_data[ITEM_max_level],\
			hnsxp_calculate_value(level, item_data[ITEM_max_level], item_data[ITEM_max_value]),\
			item_data[ITEM_max_value],\
			item_data[ITEM_value_type]);
	}
	
	len += formatex(motd[len], sizeof(motd) - len - 1,	"</td></tr></table></body></html>");
	
	show_motd(client, motd, "HNS XP Mod Player Info");
	
	ShowPlayerOptionsMenu(client);
}

ShowResetMenu(client)
{
	static title[512];
	formatex(title, sizeof(title) - 1, "[HNS XP by Exolent]^nYour XP: \w%i^n^nDo you want to reset\r ALL ABILITIES\y and\r XP\w?", g_xp[client]);
	new menu = menu_create(title, "MenuReset");
	
	menu_additem(menu, "Yes", "1");
	menu_additem(menu, "No", "2");
	
	menu_setprop(menu, MPROP_EXIT, MEXIT_NEVER);
	
	menu_display(client, menu);
}

public MenuReset(client, menu, item)
{
	if( item == MENU_EXIT )
	{
		menu_destroy(menu);
		ShowMainMenu(client);
		return;
	}
	
	static _access, info[4], callback;
	menu_item_getinfo(menu, item, _access, info, sizeof(info) - 1, _, _, callback);
	menu_destroy(menu);
	
	if( str_to_num(info) == 1 )
	{
		NewUser(client);
		Print(client, "^1 You have^3 reset all^1 of your progress!");
	}
	
	ShowMainMenu(client);
}

IsValidAuthid(authid[])
{
	return (regex_match_c(authid, g_SteamID_pattern, g_regex_return) > 0);
}

IsUserAuthorized(client)
{
	return g_authid[client][0] != 0;
}

Print(client, const message_format[], any:...)
{
	static prefix[16];
	get_pcvar_string(cvar_message_prefix, prefix, sizeof(prefix) - 1);
	
	static message[192], len;
	len = formatex(message, sizeof(message) - 1, "^4%s", prefix);
	vformat(message[len], sizeof(message) - len - 1, message_format, 3);
	
	static players[32], pnum;
	if( client )
	{
		players[0] = client;
		pnum = 1;
	}
	else
	{
		get_players(players, pnum);
	}
	
	for( new i = 0, player; i < pnum; i++ )
	{
		player = players[i];
		if( is_user_connected(player) )
		{
			message_begin(MSG_ONE_UNRELIABLE, g_msgid_SayText, _, player);
			write_byte(player);
			write_string(message);
			message_end();
		}
	}
}

Load(client)
{
	static data[32];
	if( nfv_get_data(g_vault_file, g_authid[client], "xp", data, sizeof(data) - 1) )
	{
		g_xp[client] = max(0, str_to_num(data));
		
		new ability_total = ArraySize(g_abilities);
		
		new ability_data[Ability], item_total, item_data[Item];
		for( new i = 0, j; i < ability_total; i++ )
		{
			ArrayGetArray(g_abilities, i, ability_data);
			
			item_total = ArraySize(ability_data[ABIL_items]);
			
			for( j = 0; j < item_total; j++ )
			{
				ArrayGetArray(ability_data[ABIL_items], j, item_data);
				
				item_data[ITEM_player_levels][client] = clamp(nfv_get_num(g_vault_file, g_authid[client], item_data[ITEM_save_name]), 0, item_data[ITEM_max_level]);
				
				ArraySetArray(ability_data[ABIL_items], j, item_data);
				
				ExecuteForward(g_fwd_update_user_level, g_fwd_return, i, j, client, item_data[ITEM_player_levels][client]);
			}
		}
	}
	else
	{
		NewUser(client);
	}
}

NewUser(client)
{
	g_first_time[client] = 1;
	
	g_xp[client] = get_pcvar_num(cvar_xp_entry);
	
	new ability_total = ArraySize(g_abilities);
	
	new ability_data[Ability], item_total, item_data[Item];
	for( new i = 0, j; i < ability_total; i++ )
	{
		ArrayGetArray(g_abilities, i, ability_data);
		
		item_total = ArraySize(ability_data[ABIL_items]);
		
		for( j = 0; j < item_total; j++ )
		{
			ArrayGetArray(ability_data[ABIL_items], j, item_data);
			
			item_data[ITEM_player_levels][client] = 0;
			
			ArraySetArray(ability_data[ABIL_items], j, item_data);
			
			nfv_set_num(g_vault_file, g_authid[client], item_data[ITEM_save_name], 0);
			
			ExecuteForward(g_fwd_update_user_level, g_fwd_return, i, j, client, 0);
		}
	}
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang11274\\ f0\\ fs16 \n\\ par }
*/
