#include <amxmodx>
#include <hamsandwich>
#include <hlsdk_const>
#include <cstrike>
#include <hnsxp>

// =================================================
// BEGIN EDITING HERE
// =================================================

// The xp amount required to buy the first level

#define FIRST_XP_NOFALL_T		100
#define FIRST_XP_NOFALL_CT		100

// The xp interval between levels
// Use a positive value for your own interval.
// Use XP_INTERVAL_NONE for the "first_xp" value as each interval.
// Use XP_INTERVAL_EXPONENTIAL for the xp to double for each level. (default)

#define INTERVAL_NOFALL_T		XP_INTERVAL_EXPONENTIAL
#define INTERVAL_NOFALL_CT		XP_INTERVAL_EXPONENTIAL

// The maximum level for each item

#define MAX_LEVEL_NOFALL_T		8
#define MAX_LEVEL_NOFALL_CT		6

// The maximum value possible for this item (happens when player has maximum level)

#define MAX_VALUE_NOFALL_T		80
#define MAX_VALUE_NOFALL_CT		60

// =================================================
// STOP EDITING HERE
// =================================================

new const g_ability_descs[][] =
{
	"The Fall Damage ability reduces the amount of damage inflicted from falling.",
	"The percentage value you get for your level is the percent of damage removed from the damage you take from falling."
};

new const g_item_name[CsTeams][] =
{
	"",
	"T Fall Damage Reducer",
	"CT Fall Damage Reducer",
	""
};

new const g_item_save_name[CsTeams][] =
{
	"",
	"fall_damage_reducer_t",
	"fall_damage_reducer_ct",
	""
};

new const g_item_value_type[CsTeams][] =
{
	"",
	"%",
	"%",
	""
};

new const g_item_first_xp[CsTeams] =
{
	0,
	FIRST_XP_NOFALL_T,
	FIRST_XP_NOFALL_CT,
	0
};

new const g_item_xp_interval[CsTeams] =
{
	0,
	INTERVAL_NOFALL_T,
	INTERVAL_NOFALL_CT,
	0
};

new const g_item_max_level[CsTeams] =
{
	0,
	MAX_LEVEL_NOFALL_T,
	MAX_LEVEL_NOFALL_CT,
	0
};

new const g_item_max_value[CsTeams] =
{
	0,
	MAX_VALUE_NOFALL_T,
	MAX_VALUE_NOFALL_CT,
	0
};

new g_ability_pointer;
new g_item_pointer[CsTeams];

new g_level[33][CsTeams];

public plugin_init()
{
	register_plugin("HNSXP Ability - Fall Damage", HNSXP_VERSION, "Exolent");
	
	g_ability_pointer = hnsxp_register_ability("Fall Damage");
	
	for( new CsTeams:i = CS_TEAM_T; i <= CS_TEAM_CT; i++ )
	{
		g_item_pointer[i] = hnsxp_register_item(g_ability_pointer,\
			g_item_name[i],\
			g_item_save_name[i],\
			g_item_value_type[i],\
			g_item_first_xp[i],\
			g_item_xp_interval[i],\
			g_item_max_level[i],\
			g_item_max_value[i]
		);
	}
	
	for( new i = 0; i < sizeof(g_ability_descs); i++ )
	{
		hnsxp_describe_ability(g_ability_pointer, g_ability_descs[i]);
	}
	
	RegisterHam(Ham_TakeDamage, "player", "FwdPlayerDamage");
}

public hnsxp_update_user_level(const ability, const item, const client, const level)
{
	if( ability == g_ability_pointer )
	{
		for( new CsTeams:i = CS_TEAM_T; i <= CS_TEAM_CT; i++ )
		{
			if( g_item_pointer[i] == item )
			{
				g_level[client][i] = level;
				break;
			}
		}
	}
}

public FwdPlayerDamage(client, inflictor, attacker, Float:damage, damagebits)
{
	if( is_user_alive(client) && (damagebits & DMG_FALL) )
	{
		new CsTeams:team = cs_get_user_team(client);
		if( team == CS_TEAM_T || team == CS_TEAM_CT )
		{
			new percent = hnsxp_calculate_value(g_level[client][team], g_item_max_level[team], g_item_max_value[team]);
			if( percent > 0 )
			{
				new Float:reduction = float(floatround((damage * float(percent) / 100.0), floatround_floor));
				
				SetHamParamFloat(4, damage - reduction);
				
				set_hudmessage(
					.red = 0,
					.green = 127,
					.blue = 255,
					.x = -1.0,
					.y = 0.35,
					.holdtime = 3.0,
					.channel = -1
					);
				show_hudmessage(client, "Fall Damage Reducer^nLevel %i^n^nInitial Damage: %.1f^nDamage Taken: %.1f", g_level[client][team], damage, (damage - reduction));
			}
		}
	}
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1033\\ f0\\ fs16 \n\\ par }
*/
