#include <amxmodx>
#include <hamsandwich>
#include <cstrike>
#include <hnsxp>
#include <fun>

// =================================================
// BEGIN EDITING HERE
// =================================================

// The xp amount required to buy the first level

#define FIRST_XP_GRENADE		100
#define FIRST_XP_FLASHBANG_1		100
#define FIRST_XP_FLASHBANG_2		100
#define FIRST_XP_SMOKEGRENADE		100

// The xp interval between levels
// Use a positive value for your own interval.
// Use XP_INTERVAL_NONE for the "first_xp" value as each interval.
// Use XP_INTERVAL_EXPONENTIAL for the xp to double for each level. (default)

#define INTERVAL_GRENADE		XP_INTERVAL_EXPONENTIAL
#define INTERVAL_FLASHBANG_1		XP_INTERVAL_EXPONENTIAL
#define INTERVAL_FLASHBANG_2		XP_INTERVAL_EXPONENTIAL
#define INTERVAL_SMOKEGRENADE		XP_INTERVAL_EXPONENTIAL

// The maximum level for each item

#define MAX_LEVEL_GRENADE		8
#define MAX_LEVEL_FLASHBANG_1		4
#define MAX_LEVEL_FLASHBANG_2		4
#define MAX_LEVEL_SMOKEGRENADE		4

// The maximum value possible for this item (happens when player has maximum level)

#define MAX_VALUE_GRENADE		100
#define MAX_VALUE_FLASHBANG_1		100
#define MAX_VALUE_FLASHBANG_2		100
#define MAX_VALUE_SMOKEGRENADE		100

// =================================================
// STOP EDITING HERE
// =================================================

new const g_ability_descs[][] =
{
	"The Grenades ability for the XP Mod is for Terrorists only.",
	"The Grenades ability contains the HE Grenade, 2 Flashbangs, and Smoke Grenade.",
	"These are the grenades you are given when you receive the your items after the hide timer ends.",
	"The values for each grenade are chances that you are given each time you spawn."
};

enum _:Items
{
	ITEM_HE,
	ITEM_FL1,
	ITEM_FL2,
	ITEM_SM
};

new const g_item_name[Items][] =
{
	"HE Grenade",
	"Flashbang #1",
	"Flashbang #2",
	"Frost Nade"
};

new const g_item_save_name[Items][] =
{
	"grenades_he",
	"grenades_f1",
	"grenades_f2",
	"grenades_sg"
};

new const g_item_value_type[Items][] =
{
	"%",
	"%",
	"%",
	"%"
};

new const g_item_first_xp[Items] =
{
	FIRST_XP_GRENADE,
	FIRST_XP_FLASHBANG_1,
	FIRST_XP_FLASHBANG_2,
	FIRST_XP_SMOKEGRENADE
};

new const g_item_xp_interval[Items] =
{
	INTERVAL_GRENADE,
	INTERVAL_FLASHBANG_1,
	INTERVAL_FLASHBANG_2,
	INTERVAL_SMOKEGRENADE
};

new const g_item_max_level[Items] =
{
	MAX_LEVEL_GRENADE,
	MAX_LEVEL_FLASHBANG_1,
	MAX_LEVEL_FLASHBANG_2,
	MAX_LEVEL_SMOKEGRENADE
};

new const g_item_max_value[Items] =
{
	MAX_VALUE_GRENADE,
	MAX_VALUE_FLASHBANG_1,
	MAX_VALUE_FLASHBANG_2,
	MAX_VALUE_SMOKEGRENADE
};

new const g_nade_classnames[Items][] =
{
	"weapon_hegrenade",
	"weapon_flashbang",
	"weapon_flashbang",
	"weapon_smokegrenade"
};

new g_ability_pointer;
new g_item_pointer[Items];

new g_level[33][Items];

new cvar_spawn_nade_delay;

new Float:g_nade_give_time;

new g_first_client;
new g_max_clients;

public plugin_init()
{
	register_plugin("HNSXP Ability - Grenades", HNSXP_VERSION, "Exolent");
	
	g_ability_pointer = hnsxp_register_ability("Grenades");
	
	for( new i = 0; i < Items; i++ )
	{
		g_item_pointer[i] = hnsxp_register_item(g_ability_pointer,\
			g_item_name[i],\
			g_item_save_name[i],\
			g_item_value_type[i],\
			g_item_first_xp[i],\
			g_item_xp_interval[i],\
			g_item_max_level[i],\
			g_item_max_value[i]
		);
	}
	
	for( new i = 0; i < sizeof(g_ability_descs); i++ )
	{
		hnsxp_describe_ability(g_ability_pointer, g_ability_descs[i]);
	}
	
	RegisterHam(Ham_Spawn, "player", "FwdPlayerSpawn", 1);
	
	register_event("HLTV", "EventNewRound", "a", "1=0", "2=0");
	register_logevent("EventRoundStart", 2, "1=Round_Start");
	register_event("TextMsg", "EventRoundRestart", "a", "2&#Game_C", "2&#Game_w");
	
	cvar_spawn_nade_delay = register_cvar("hnsxp_spawn_nade_delay", "10");
	
	g_first_client = 1;
	g_max_clients = get_maxplayers();
}

public hnsxp_update_user_level(const ability, const item, const client, const level)
{
	if( ability == g_ability_pointer )
	{
		for( new i = 0; i < Items; i++ )
		{
			if( g_item_pointer[i] == item )
			{
				g_level[client][i] = level;
				break;
			}
		}
	}
}

public FwdPlayerSpawn(client)
{
	if( is_user_alive(client) )
	{
		if( get_gametime() >= g_nade_give_time )
		{
			GiveNades(client);
		}
	}
}

public EventNewRound()
{
	g_nade_give_time = 9999999.9;
}

public EventRoundStart()
{
	g_nade_give_time = get_pcvar_float(cvar_spawn_nade_delay);
	
	set_task(g_nade_give_time, "TaskGiveNades", 1234);
	
	g_nade_give_time += get_gametime();
}

public EventRoundRestart()
{
	remove_task(1234);
	
	g_nade_give_time = 9999999.9;
}

public TaskGiveNades()
{
	for( new client = g_first_client; client <= g_max_clients; client++ )
	{
		if( is_user_alive(client) )
		{
			GiveNades(client);
		}
	}
}

GiveNades(client)
{
	new CsTeams:team = cs_get_user_team(client);
	
	if( team == CS_TEAM_T )
	{
		static percent;
		for( new i = 0; i < Items; i++ )
		{
			percent = g_item_max_value[i] * g_level[client][i] / g_item_max_level[i];
			if( percent > 0 && (percent == 100 || random_num(1, 100) <= percent) )
			{
				give_item(client, g_nade_classnames[i]);
				
				if( percent < 100 )
				{
					hnsxp_print(client, "^1 You received your^3 %s^1! (%i%s)", g_item_name[i], percent, g_item_value_type[i]);
				}
			}
		}
	}
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1033\\ f0\\ fs16 \n\\ par }
*/
