#include <amxmodx>
#include <hamsandwich>
#include <cstrike>
#include <hnsxp>
#include <fun>

// =================================================
// BEGIN EDITING HERE
// =================================================

// The xp amount required to buy the first level

#define FIRST_XP_HEALTH_T		100
#define FIRST_XP_HEALTH_CT		100

// The xp interval between levels
// Use a positive value for your own interval.
// Use XP_INTERVAL_NONE for the "first_xp" value as each interval.
// Use XP_INTERVAL_EXPONENTIAL for the xp to double for each level. (default)

#define INTERVAL_HEALTH_T		XP_INTERVAL_EXPONENTIAL
#define INTERVAL_HEALTH_CT		XP_INTERVAL_EXPONENTIAL

// The maximum level for each item

#define MAX_LEVEL_HEALTH_T		10
#define MAX_LEVEL_HEALTH_CT		5

// The maximum value possible for this item (happens when player has maximum level)

#define MAX_VALUE_HEALTH_T		100
#define MAX_VALUE_HEALTH_CT		50

// =================================================
// STOP EDITING HERE
// =================================================

new const g_ability_descs[][] =
{
	"The Extra Health ability is the amount of HP that is added to your spawn health."
};

new const g_item_name[CsTeams][] =
{
	"",
	"T Extra Health",
	"CT Extra Health",
	""
};

new const g_item_save_name[CsTeams][] =
{
	"",
	"extra_health_t",
	"extra_health_ct",
	""
};

new const g_item_value_type[CsTeams][] =
{
	"",
	" HP",
	" HP",
	""
};

new const g_item_first_xp[CsTeams] =
{
	0,
	FIRST_XP_HEALTH_T,
	FIRST_XP_HEALTH_CT,
	0
};

new const g_item_xp_interval[CsTeams] =
{
	0,
	INTERVAL_HEALTH_T,
	INTERVAL_HEALTH_CT,
	0
};

new const g_item_max_level[CsTeams] =
{
	0,
	MAX_LEVEL_HEALTH_T,
	MAX_LEVEL_HEALTH_CT,
	0
};

new const g_item_max_value[CsTeams] =
{
	0,
	MAX_VALUE_HEALTH_T,
	MAX_VALUE_HEALTH_CT,
	0
};

new g_ability_pointer;
new g_item_pointer[CsTeams];

new g_level[33][CsTeams];

public plugin_init()
{
	register_plugin("HNSXP Ability - Extra Health", HNSXP_VERSION, "Exolent");
	
	g_ability_pointer = hnsxp_register_ability("Extra Health");
	
	for( new CsTeams:i = CS_TEAM_T; i <= CS_TEAM_CT; i++ )
	{
		g_item_pointer[i] = hnsxp_register_item(g_ability_pointer,\
			g_item_name[i],\
			g_item_save_name[i],\
			g_item_value_type[i],\
			g_item_first_xp[i],\
			g_item_xp_interval[i],\
			g_item_max_level[i],\
			g_item_max_value[i]
		);
	}
	
	for( new i = 0; i < sizeof(g_ability_descs); i++ )
	{
		hnsxp_describe_ability(g_ability_pointer, g_ability_descs[i]);
	}
	
	RegisterHam(Ham_Spawn, "player", "FwdPlayerSpawn", 1);
}

public hnsxp_update_user_level(const ability, const item, const client, const level)
{
	if( ability == g_ability_pointer )
	{
		for( new CsTeams:i = CS_TEAM_T; i <= CS_TEAM_CT; i++ )
		{
			if( g_item_pointer[i] == item )
			{
				g_level[client][i] = level;
				break;
			}
		}
	}
}

public FwdPlayerSpawn(client)
{
	if( is_user_alive(client) )
	{
		new CsTeams:team = cs_get_user_team(client);
		if( team == CS_TEAM_T || team == CS_TEAM_CT )
		{
			new value = hnsxp_calculate_value(g_level[client][team], g_item_max_level[team], g_item_max_value[team]);
			if( value > 0 )
			{
				set_user_health(client, get_user_health(client) + value);
				
				hnsxp_print(client, "^1 You got^3 %i%s^1 for having^3 %s Level %i^1!", value, g_item_value_type[team], g_item_name[team], g_level[client][team]);
			}
		}
	}
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1033\\ f0\\ fs16 \n\\ par }
*/
