#include <amxmodx>
#include <hamsandwich>
#include <fakemeta>
#include <cstrike>
#include <hnsxp>

// =================================================
// BEGIN EDITING HERE
// =================================================

// The xp amount required to buy the first level

#define FIRST_XP_INVIS_T		500
#define FIRST_XP_INVIS_CT		500

// The xp interval between levels
// Use a positive value for your own interval.
// Use XP_INTERVAL_NONE for the "first_xp" value as each interval.
// Use XP_INTERVAL_EXPONENTIAL for the xp to double for each level. (default)

#define INTERVAL_INVIS_T		XP_INTERVAL_EXPONENTIAL
#define INTERVAL_INVIS_CT		XP_INTERVAL_EXPONENTIAL

// The maximum level for each item

#define MAX_LEVEL_INVIS_T		8
#define MAX_LEVEL_INVIS_CT		6

// The maximum value possible for this item (happens when player has maximum level)
// Note: THIS SHOULD NOT BE GREATER THAN 255!

#define MAX_VALUE_INVIS_T		200
#define MAX_VALUE_INVIS_CT		150

// How many seconds it takes from being damaged to go back to your maximum invisible level

#define DAMAGE_ALPHA_RESET		6

// =================================================
// STOP EDITING HERE
// =================================================

#define TASK_ID_RESET			1234

#define IN_MOVEMENT			(IN_FORWARD|IN_MOVELEFT|IN_MOVERIGHT|IN_BACK)

new const g_ability_descs[][] =
{
	"The Invisible ability makes you transparent.",
	"The higher level you get, the less visible you become.",
	"When you take damage, you will be completely visible, then slowly become less visible.",
	"When you move, you will be only 50% of your level's visibility. So instead of being 200 invisibility, you would be at 100."
};

new const g_item_name[CsTeams][] =
{
	"",
	"T Invisibility",
	"CT Invisibility",
	""
};

new const g_item_save_name[CsTeams][] =
{
	"",
	"invisible_t",
	"invisible_ct",
	""
};

new const g_item_value_type[CsTeams][] =
{
	"",
	" invisibility",
	" invisibility",
	""
};

new const g_item_first_xp[CsTeams] =
{
	0,
	FIRST_XP_INVIS_T,
	FIRST_XP_INVIS_CT,
	0
};

new const g_item_xp_interval[CsTeams] =
{
	0,
	INTERVAL_INVIS_T,
	INTERVAL_INVIS_CT,
	0
};

new const g_item_max_level[CsTeams] =
{
	0,
	MAX_LEVEL_INVIS_T,
	MAX_LEVEL_INVIS_CT,
	0
};

new const g_item_max_value[CsTeams] =
{
	0,
	MAX_VALUE_INVIS_T,
	MAX_VALUE_INVIS_CT,
	0
};

new g_ability_pointer;
new g_item_pointer[CsTeams];

new g_level[33][CsTeams];

new g_alpha[33];
new g_moving[33];
new g_stop_alpha[33];
new g_interval[33];

public plugin_init()
{
	register_plugin("HNSXP Ability - Invisible", HNSXP_VERSION, "Exolent");
	
	g_ability_pointer = hnsxp_register_ability("Invisible");
	
	for( new CsTeams:i = CS_TEAM_T; i <= CS_TEAM_CT; i++ )
	{
		g_item_pointer[i] = hnsxp_register_item(g_ability_pointer,\
			g_item_name[i],\
			g_item_save_name[i],\
			g_item_value_type[i],\
			g_item_first_xp[i],\
			g_item_xp_interval[i],\
			g_item_max_level[i],\
			g_item_max_value[i]
		);
	}
	
	for( new i = 0; i < sizeof(g_ability_descs); i++ )
	{
		hnsxp_describe_ability(g_ability_pointer, g_ability_descs[i]);
	}
	
	register_forward(FM_CmdStart, "FwdCmdStart");
	register_forward(FM_AddToFullPack, "FwdAddToFullPack", 1);
	
	RegisterHam(Ham_Spawn, "player", "FwdPlayerSpawn", 1);
	RegisterHam(Ham_Killed, "player", "FwdPlayerDeath", 1);
	RegisterHam(Ham_TakeDamage, "player", "FwdPlayerDamage");
}

public client_disconnect(client)
{
	g_alpha[client] = 255;
	g_moving[client] = 0;
	remove_task(TASK_ID_RESET + client);
}

public hnsxp_update_user_level(const ability, const item, const client, const level)
{
	if( ability == g_ability_pointer )
	{
		for( new CsTeams:i = CS_TEAM_T; i <= CS_TEAM_CT; i++ )
		{
			if( g_item_pointer[i] == item )
			{
				g_level[client][i] = level;
				break;
			}
		}
	}
}

public FwdCmdStart(client, uc_handle, random_seed)
{
	if( is_user_alive(client) )
	{
		new buttons = get_uc(uc_handle, UC_Buttons);
		g_moving[client] = ( buttons & IN_MOVEMENT || (buttons & IN_JUMP) && !(pev(client, pev_oldbuttons) & IN_JUMP) );
	}
}

public FwdAddToFullPack(es, e, ent, host, host_flags, player, pSet)
{
	if( player )
	{
		if( g_alpha[ent] != 255 && cs_get_user_team(ent) != cs_get_user_team(host) )
		{
			set_es(es, ES_RenderMode, kRenderTransAdd);
			set_es(es, ES_RenderAmt, g_alpha[ent] / (g_moving[ent] + 1));
		}
	}
}

public FwdPlayerSpawn(client)
{
	if( is_user_alive(client) )
	{
		new CsTeams:team = cs_get_user_team(client);
		if( team == CS_TEAM_T || team == CS_TEAM_CT )
		{
			new alpha = hnsxp_calculate_value(g_level[client][team], g_item_max_level[team], g_item_max_value[team]);
			
			g_alpha[client] = 255 - alpha;
			g_moving[client] = 1;
			remove_task(TASK_ID_RESET + client);
		}
	}
}

public FwdPlayerDeath(client, killer, shouldgib)
{
	g_alpha[client] = 255;
	g_moving[client] = 0;
	remove_task(TASK_ID_RESET + client);
}

public FwdPlayerDamage(client, inflictor, attacker, Float:damage, damagebits)
{
	if( is_user_alive(client) )
	{
		new CsTeams:team = cs_get_user_team(client);
		if( team == CS_TEAM_T || team == CS_TEAM_CT )
		{
			new alpha = hnsxp_calculate_value(g_level[client][team], g_item_max_level[team], g_item_max_value[team]);
			if( alpha > 0 )
			{
				g_alpha[client] = 255;
				g_interval[client] = 0;
				g_stop_alpha[client] = alpha;
				
				remove_task(TASK_ID_RESET + client);
				set_task(1.0, "TaskResetAlpha", (TASK_ID_RESET + client));
			}
		}
	}
}

public TaskResetAlpha(taskid)
{
	new client = taskid - TASK_ID_RESET;
	
	if( ++g_interval[client] <= DAMAGE_ALPHA_RESET )
	{
		g_alpha[client] = 255 - hnsxp_calculate_value(g_interval[client], DAMAGE_ALPHA_RESET, g_stop_alpha[client]);
		
		if( g_interval[client] < DAMAGE_ALPHA_RESET )
		{
			set_task(1.0, "TaskResetAlpha", (TASK_ID_RESET + client));
		}
	}
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1033\\ f0\\ fs16 \n\\ par }
*/
