#include <amxmodx>
#include <hamsandwich>
#include <cstrike>
#include <hnsxp>

// =================================================
// BEGIN EDITING HERE
// =================================================

// The xp amount required to buy the first level

#define FIRST_XP_RESPAWN_T		1000
#define FIRST_XP_RESPAWN_CT		2000

// The xp interval between levels
// Use a positive value for your own interval.
// Use XP_INTERVAL_NONE for the "first_xp" value as each interval.
// Use XP_INTERVAL_EXPONENTIAL for the xp to double for each level. (default)

#define INTERVAL_RESPAWN_T		XP_INTERVAL_EXPONENTIAL
#define INTERVAL_RESPAWN_CT		XP_INTERVAL_EXPONENTIAL

// The maximum level for each item

#define MAX_LEVEL_RESPAWN_T		2
#define MAX_LEVEL_RESPAWN_CT		2

// The maximum value possible for this item (happens when player has maximum level)

#define MAX_VALUE_RESPAWN_T		50
#define MAX_VALUE_RESPAWN_CT		50

// =================================================
// STOP EDITING HERE
// =================================================

new const g_ability_descs[][] =
{
	"The Respawn ability is chance to be respawned when you die."
};

new const g_item_name[CsTeams][] =
{
	"",
	"T Respawn Chance",
	"CT Respawn Chance",
	""
};

new const g_item_save_name[CsTeams][] =
{
	"",
	"respawn_t",
	"respawn_ct",
	""
};

new const g_item_value_type[CsTeams][] =
{
	"",
	"%",
	"%",
	""
};

new const g_item_first_xp[CsTeams] =
{
	0,
	FIRST_XP_RESPAWN_T,
	FIRST_XP_RESPAWN_CT,
	0
};

new const g_item_xp_interval[CsTeams] =
{
	0,
	INTERVAL_RESPAWN_T,
	INTERVAL_RESPAWN_CT,
	0
};

new const g_item_max_level[CsTeams] =
{
	0,
	MAX_LEVEL_RESPAWN_T,
	MAX_LEVEL_RESPAWN_CT,
	0
};

new const g_item_max_value[CsTeams] =
{
	0,
	MAX_VALUE_RESPAWN_T,
	MAX_VALUE_RESPAWN_CT,
	0
};

new g_ability_pointer;
new g_item_pointer[CsTeams];

new g_level[33][CsTeams];

new g_used_revive[33];

new g_first_client;
new g_max_clients;

public plugin_init()
{
	register_plugin("HNSXP Ability - Respawn", HNSXP_VERSION, "Exolent");
	
	g_ability_pointer = hnsxp_register_ability("Respawn");
	
	for( new CsTeams:i = CS_TEAM_T; i <= CS_TEAM_CT; i++ )
	{
		g_item_pointer[i] = hnsxp_register_item(g_ability_pointer,\
			g_item_name[i],\
			g_item_save_name[i],\
			g_item_value_type[i],\
			g_item_first_xp[i],\
			g_item_xp_interval[i],\
			g_item_max_level[i],\
			g_item_max_value[i]
		);
	}
	
	for( new i = 0; i < sizeof(g_ability_descs); i++ )
	{
		hnsxp_describe_ability(g_ability_pointer, g_ability_descs[i]);
	}
	
	register_event("HLTV", "EventNewRound", "a", "1=0", "2=0");
	
	RegisterHam(Ham_Killed, "player", "FwdPlayerDeath", 1);
	
	g_first_client = 1;
	g_max_clients = get_maxplayers();
}

public hnsxp_update_user_level(const ability, const item, const client, const level)
{
	if( ability == g_ability_pointer )
	{
		for( new CsTeams:i = CS_TEAM_T; i <= CS_TEAM_CT; i++ )
		{
			if( g_item_pointer[i] == item )
			{
				g_level[client][i] = level;
				break;
			}
		}
	}
}

public client_disconnect(client)
{
	g_used_revive[client] = 0;
}

public EventNewRound()
{
	arrayset(g_used_revive, 0, sizeof(g_used_revive));
}

public FwdPlayerDeath(client, killer, shouldgib)
{
	if( !g_used_revive[client] )
	{
		new CsTeams:team = cs_get_user_team(client);
		if( team == CS_TEAM_T || team == CS_TEAM_CT )
		{
			new percent = hnsxp_calculate_value(g_level[client][team], g_item_max_level[team], g_item_max_value[team]);
			if( percent > 0 && (percent >= 100 || random_num(1, 100) <= percent) )
			{
				if( HasTeammateAlive(client, team) )
				{
					set_task(0.5, "TaskRespawn", client);
					
					hnsxp_print(client, "^1 You have been^3 respawned^1!(%i%% chance)", percent);
					
					g_used_revive[client] = 1;
				}
			}
		}
	}
}

public TaskRespawn(client)
{
	ExecuteHamB(Ham_CS_RoundRespawn, client);
}

HasTeammateAlive(client, CsTeams:team)
{
	for( new i = g_first_client; i <= g_max_clients; i++ )
	{
		if( i != client && is_user_alive(i) && cs_get_user_team(i) == team )
		{
			return 1;
		}
	}
	
	return 0;
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1033\\ f0\\ fs16 \n\\ par }
*/
